﻿package
{
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.KeyboardEvent;
	import flash.display.*;
	import flash.geom.*;
	import flash.filters.GlowFilter;
	import flash.filters.BlurFilter;
	

	public class Brancher extends Sprite
	{
		private var rot:Number;
		private var theta:Number=0;
		private var stack:Array = new Array();
		private var i:Number;
		private var centerX:Number;
		private var centerY:Number;
		private var fillType:String = GradientType.RADIAL;
		var spreadMethod:String = SpreadMethod.REFLECT;
		private var colors:Array = [0x000000,0x009C58];
		private var alphas:Array = [1,1];
		private var ratios:Array = [100,255];
		private var matr:Matrix  = new Matrix();
		private var glowFilter:GlowFilter;
		private var blurFilter:BlurFilter;
		
		public function Brancher()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(MouseEvent.MOUSE_DOWN,clickHandler);
			stage.addEventListener(KeyboardEvent.KEY_DOWN, eraseHandler);
		}
		
		private function eraseHandler(e:KeyboardEvent):void{
			//trace("KEY");
			while(numChildren>0){
				removeChildAt(0);
			}
		}
		
		private function clickHandler(e:MouseEvent):void
		{
			centerX = e.stageX;
			centerY = e.stageY;
			theta= Math.random()*360;
			i=0;
			colors = [0x000000,Math.random()*0xFFFFFF]
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function enterHandler(e:Event):void
		{	
			rot=+30*Math.sin(Math.PI / 180 * theta);
			theta-=0.2;
			if(i<100){
				glowFilter = new GlowFilter();
				glowFilter.blurX = 10;
				glowFilter.blurY = 10;
				glowFilter.color = 0x000000;
				glowFilter.alpha = 0.5;
				blurFilter = new BlurFilter();
				blurFilter.blurX = 1.5+i/8;
				blurFilter.blurY = 1.5+i/8;
				blurFilter.quality = 100;
 				stack[i] = new Sprite();
				stack[i].filters = [blurFilter]
				matr.createGradientBox(30,30,10,0,0);
				stack[i].graphics.beginGradientFill(fillType,colors,alphas,ratios,matr,spreadMethod);
				//stack[i].graphics.lineStyle(.2,0xff0000,1);
				stack[i].graphics.drawCircle(0,0,20);
				stack[i].x = mouseX+Math.cos(rot)*i*3;
				stack[i].y = mouseY-Math.sin(rot)*i*3;
				stack[i].scaleX =1-i*0.05;
				stack[i].scaleY =1-i*0.05;
				addChild(stack[i]);
				i++;
			}else{
				removeEventListener(Event.ENTER_FRAME,enterHandler);
			}
		}
	}
}